config/routes.rb
# frozen_string_literal: true
Rails.application.routes.draw do
  resources :user_infos
  resources :blogs
  devise_for :users
  root to: 'blogs#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/blog.rb
class Blog < ApplicationRecord
  belongs_to :user
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
  has_many :blogs
  has_one :user_info
  after_create :create_user_info
  def create_user_info
    UserInfo.create_or_find_by(:user_id => self.id)
  end

end

app/models/user_info.rb
class UserInfo < ApplicationRecord
  belongs_to :user
  has_one_attached :avatar
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :authenticate_user!
end

app/controllers/blogs_controller.rb
class BlogsController < ApplicationController
  before_action :set_blog, only: %i[ show edit update destroy ]

  # GET /blogs or /blogs.json
  def index
    @blogs = Blog.all
  end

  # GET /blogs/1 or /blogs/1.json
  def show
  end

  # GET /blogs/new
  def new
    @blog = Blog.new
  end

  # GET /blogs/1/edit
  def edit
  end

  # POST /blogs or /blogs.json
  def create
    @blog = Blog.new(blog_params)

    respond_to do |format|
      if @blog.save
        format.html { redirect_to @blog, notice: "Blog was successfully created." }
        format.json { render :show, status: :created, location: @blog }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @blog.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /blogs/1 or /blogs/1.json
  def update
    respond_to do |format|
      if @blog.update(blog_params)
        format.html { redirect_to @blog, notice: "Blog was successfully updated." }
        format.json { render :show, status: :ok, location: @blog }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @blog.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /blogs/1 or /blogs/1.json
  def destroy
    @blog.destroy
    respond_to do |format|
      format.html { redirect_to blogs_url, notice: "Blog was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_blog
      @blog = Blog.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def blog_params
      params.require(:blog).permit(:title, :body, :user_id)
    end
end

app/controllers/user_infos_controller.rb
class UserInfosController < ApplicationController
  before_action :set_user_info, only: %i[ show edit update destroy ]

  # GET /user_infos or /user_infos.json
  def index
    @user_infos = UserInfo.all
  end

  # GET /user_infos/1 or /user_infos/1.json
  def show
  end

  # GET /user_infos/new
  def new
    @user_info = UserInfo.new
  end

  # GET /user_infos/1/edit
  def edit
  end

  # POST /user_infos or /user_infos.json
  def create
    @user_info = UserInfo.new(user_info_params)

    respond_to do |format|
      if @user_info.save
        format.html { redirect_to @user_info, notice: "User info was successfully created." }
        format.json { render :show, status: :created, location: @user_info }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @user_info.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /user_infos/1 or /user_infos/1.json
  def update
    respond_to do |format|
      if @user_info.update(user_info_params)
        format.html { redirect_to @user_info, notice: "User info was successfully updated." }
        format.json { render :show, status: :ok, location: @user_info }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @user_info.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /user_infos/1 or /user_infos/1.json
  def destroy
    @user_info.destroy
    respond_to do |format|
      format.html { redirect_to user_infos_url, notice: "User info was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_user_info
      @user_info = UserInfo.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def user_info_params
      params.require(:user_info).permit(:first_name, :last_name, :secondary_email, :gender, :user_id, :phone, :street_address_1, :land_mark_1, :city_1, :district_1, :state_1, :country_1, :street_address_2, :land_mark_2, :city_2, :district_2, :state_2, :country_2, :avatar)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/blogs_helper.rb
module BlogsHelper
end

app/helpers/user_infos_helper.rb
module UserInfosHelper
end

app/views/blogs/_form.html.erb
<%= form_with(model: blog, local: true) do |form| %>
  <% if blog.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(blog.errors.count, "error") %> prohibited this blog from being saved:</h2>

      <ul>
        <% blog.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :title %>
    <%= form.text_field :title %>
  </div>

  <div class="field">
    <%= form.label :body %>
    <%= form.text_area :body %>
  </div>

  <div class="field">
    <%= form.label :user_id %>
    <%= form.number_field :user_id %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/blogs/edit.html.erb
<h1>Editing Blog</h1>

<%= render 'form', blog: @blog %>

<%= link_to 'Show', @blog %> |
<%= link_to 'Back', blogs_path %>

app/views/blogs/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Blogs</h1>

<table>
  <thead>
    <tr>
      <th>Title</th>
      <th>Body</th>
      <th>User</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @blogs.each do |blog| %>
      <tr>
        <td><%= blog.title %></td>
        <td><%= blog.body %></td>
        <td><%= blog.user_id %></td>
        <td><%= link_to 'Show', blog %></td>
        <td><%= link_to 'Edit', edit_blog_path(blog) %></td>
        <td><%= link_to 'Destroy', blog, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Blog', new_blog_path %>

app/views/blogs/new.html.erb
<h1>New Blog</h1>

<%= render 'form', blog: @blog %>

<%= link_to 'Back', blogs_path %>

app/views/blogs/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Title:</strong>
  <%= @blog.title %>
</p>

<p>
  <strong>Body:</strong>
  <%= @blog.body %>
</p>

<p>
  <strong>User:</strong>
  <%= @blog.user_id %>
</p>

<%= link_to 'Edit', edit_blog_path(@blog) %> |
<%= link_to 'Back', blogs_path %>

app/views/layouts/_nav.html.erb
<nav>
  <ul>
    <% if current_user %>
      <div>
        <%= image_tag(current_user.user_info.avatar,class: 'small-avatar' ) if current_user.user_info.avatar rescue nil %>
      <p><%= current_user.user_info.first_name %> <%= current_user.user_info.last_name %></p>
      </div>
      <li><%= link_to("Home", blogs_path) %></li>
      <li><%= link_to("Log Out", destroy_user_session_path, method: :delete) %></li>
      <li><%= link_to("Edit Profile", edit_user_info_path(current_user.user_info)) %></li>
    <% end %>
  </ul>
</nav>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>InfoBlogs</title>
  <%= csrf_meta_tags %>
  <%= csp_meta_tag %>

  <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
  <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
</head>

<body>
<% if notice %>
  <p class="alert alert-success"><%= notice %></p>
<% end %>
<% if alert %>
  <p class="alert alert-danger"><%= alert %></p>
<% end %>
<%= render 'layouts/nav' %>
<%= yield %>
</body>
</html>

app/views/user_infos/_form.html.erb
<%= form_with(model: user_info, local: true) do |form| %>
  <% if user_info.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(user_info.errors.count, "error") %> prohibited this user_info from being saved:</h2>

      <ul>
        <% user_info.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field" >
    <%= form.label :avatar %>
    <%= form.file_field :avatar %>
  </div>

  <div class="field">
    <%= form.label :first_name %>
    <%= form.text_field :first_name %>
  </div>

  <div class="field">
    <%= form.label :last_name %>
    <%= form.text_field :last_name %>
  </div>

  <div class="field">
    <%= form.label :secondary_email %>
    <%= form.text_field :secondary_email %>
  </div>

  <div class="field">
    <%= form.label :gender %>
    <%= form.text_field :gender %>
  </div>

  <div class="field">
    <%= form.label :user_id %>
    <%= form.text_field :user_id  ,disabled: "true" %>
  </div>

  <div class="field">
    <%= form.label :phone %>
    <%= form.text_field :phone %>
  </div>

  <div class="field">
    <%= form.label :street_address_1 %>
    <%= form.text_field :street_address_1 %>
  </div>

  <div class="field">
    <%= form.label :land_mark_1 %>
    <%= form.text_field :land_mark_1 %>
  </div>

  <div class="field">
    <%= form.label :city_1 %>
    <%= form.text_field :city_1 %>
  </div>

  <div class="field">
    <%= form.label :district_1 %>
    <%= form.text_field :district_1 %>
  </div>

  <div class="field">
    <%= form.label :state_1 %>
    <%= form.text_field :state_1 %>
  </div>

  <div class="field">
    <%= form.label :country_1 %>
    <%= form.text_field :country_1 %>
  </div>

  <div class="field">
    <%= form.label :street_address_2 %>
    <%= form.text_field :street_address_2 %>
  </div>

  <div class="field">
    <%= form.label :land_mark_2 %>
    <%= form.text_field :land_mark_2 %>
  </div>

  <div class="field">
    <%= form.label :city_2 %>
    <%= form.text_field :city_2 %>
  </div>

  <div class="field">
    <%= form.label :district_2 %>
    <%= form.text_field :district_2 %>
  </div>

  <div class="field">
    <%= form.label :state_2 %>
    <%= form.text_field :state_2 %>
  </div>

  <div class="field">
    <%= form.label :country_2 %>
    <%= form.text_field :country_2 %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/user_infos/edit.html.erb
<h1>Editing User Info</h1>

<%= render 'form', user_info: @user_info %>

<%= link_to 'Show', @user_info %> |
<%= link_to 'Back', user_infos_path %>

app/views/user_infos/index.html.erb
<p id="notice"><%= notice %></p>

<h1>User Infos</h1>

<table>
  <thead>
    <tr>
      <th>First name</th>
      <th>Last name</th>
      <th>Secondary email</th>
      <th>Gender</th>
      <th>User</th>
      <th>Phone</th>
      <th>Street address 1</th>
      <th>Land mark 1</th>
      <th>City 1</th>
      <th>District 1</th>
      <th>State 1</th>
      <th>Country 1</th>
      <th>Street address 2</th>
      <th>Land mark 2</th>
      <th>City 2</th>
      <th>District 2</th>
      <th>State 2</th>
      <th>Country 2</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @user_infos.each do |user_info| %>
      <tr>
        <td><%= user_info.first_name %></td>
        <td><%= user_info.last_name %></td>
        <td><%= user_info.secondary_email %></td>
        <td><%= user_info.gender %></td>
        <td><%= user_info.user_id %></td>
        <td><%= user_info.phone %></td>
        <td><%= user_info.street_address_1 %></td>
        <td><%= user_info.land_mark_1 %></td>
        <td><%= user_info.city_1 %></td>
        <td><%= user_info.district_1 %></td>
        <td><%= user_info.state_1 %></td>
        <td><%= user_info.country_1 %></td>
        <td><%= user_info.street_address_2 %></td>
        <td><%= user_info.land_mark_2 %></td>
        <td><%= user_info.city_2 %></td>
        <td><%= user_info.district_2 %></td>
        <td><%= user_info.state_2 %></td>
        <td><%= user_info.country_2 %></td>
        <td><%= link_to 'Show', user_info %></td>
        <td><%= link_to 'Edit', edit_user_info_path(user_info) %></td>
        <td><%= link_to 'Destroy', user_info, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New User Info', new_user_info_path %>

app/views/user_infos/new.html.erb
<h1>New User Info</h1>

<%= render 'form', user_info: @user_info %>

<%= link_to 'Back', user_infos_path %>

app/views/user_infos/show.html.erb
<p id="notice"><%= notice %></p>

<div class="avatar">
  <%= image_tag(@user_info.avatar) %>
</div>
<p>
  <strong>First name:</strong>
  <%= @user_info.first_name %>
</p>

<p>
  <strong>Last name:</strong>
  <%= @user_info.last_name %>
</p>

<p>
  <strong>Secondary email:</strong>
  <%= @user_info.secondary_email %>
</p>

<p>
  <strong>Gender:</strong>
  <%= @user_info.gender %>
</p>

<p>
  <strong>User:</strong>
  <%= @user_info.user_id %>
</p>

<p>
  <strong>Phone:</strong>
  <%= @user_info.phone %>
</p>

<p>
  <strong>Street address 1:</strong>
  <%= @user_info.street_address_1 %>
</p>

<p>
  <strong>Land mark 1:</strong>
  <%= @user_info.land_mark_1 %>
</p>

<p>
  <strong>City 1:</strong>
  <%= @user_info.city_1 %>
</p>

<p>
  <strong>District 1:</strong>
  <%= @user_info.district_1 %>
</p>

<p>
  <strong>State 1:</strong>
  <%= @user_info.state_1 %>
</p>

<p>
  <strong>Country 1:</strong>
  <%= @user_info.country_1 %>
</p>

<p>
  <strong>Street address 2:</strong>
  <%= @user_info.street_address_2 %>
</p>

<p>
  <strong>Land mark 2:</strong>
  <%= @user_info.land_mark_2 %>
</p>

<p>
  <strong>City 2:</strong>
  <%= @user_info.city_2 %>
</p>

<p>
  <strong>District 2:</strong>
  <%= @user_info.district_2 %>
</p>

<p>
  <strong>State 2:</strong>
  <%= @user_info.state_2 %>
</p>

<p>
  <strong>Country 2:</strong>
  <%= @user_info.country_2 %>
</p>

<%= link_to 'Edit', edit_user_info_path(@user_info) %> |
<%= link_to 'Back', user_infos_path %>